// src/common/data/list.ts
function listQuery(list, filters, mappers = []) {
  return list.filter((o) => !filters.some((a) => !a(o))).map((o) => {
    for (const m of mappers)
      o = m(o);
    return o;
  }).filter((o) => o != null);
}
function listGroupBy(list, key) {
  return list.reduce((result, currentValue) => {
    const groupValue = String(currentValue[key]);
    (result[groupValue] = result[groupValue] || []).push(currentValue);
    return result;
  }, {});
}
function listDistinctUnion(list, key) {
  return Array.from(
    list.reduce(
      (result, currentValue) => result.add(currentValue[key]),
      /* @__PURE__ */ new Set()
    )
  );
}
function listOfKey(list, key) {
  return list.map((item) => item[key]);
}

export {
  listQuery,
  listGroupBy,
  listDistinctUnion,
  listOfKey
};
//# sourceMappingURL=chunk-2HWPZ6ZE.js.map