"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }

var _chunkQLIFS36Ccjs = require('./chunk-QLIFS36C.cjs');


var _chunk7L2G4SFKcjs = require('./chunk-7L2G4SFK.cjs');


var _chunkC5DWDWUScjs = require('./chunk-C5DWDWUS.cjs');


var _chunkLXSY24WIcjs = require('./chunk-LXSY24WI.cjs');

// src/common/msg/pubsub.ts
var PubSub = class extends _chunk7L2G4SFKcjs.Emitter {
  constructor(opt) {
    super();
    this.publish = this.emit.bind(this);
    this.subscribe = this.on.bind(this);
    const { name, encoder = new (0, _chunkQLIFS36Ccjs.JsonEncoder)(), channel, debug = false } = opt;
    this.channel = channel;
    this.encoder = encoder;
    this.debug = debug;
    this.name = _nullishCoalesce(_nullishCoalesce(name, () => ( this.channel.id)), () => ( _chunkC5DWDWUScjs.uname.call(void 0, "pubsub")));
    this.log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, `${this.shortId}`);
    if (this.debug) {
      this.channel.on("connect", () => {
        this.log("channel connected");
      });
      this.channel.on("disconnect", () => {
        this.log("channel disconnected");
      });
    }
    this.channel.on("message", async ({ data }) => {
      const info = await this.encoder.decode(data);
      if (this.debug)
        this.log(`channel message, event=${_optionalChain([info, 'optionalAccess', _ => _.event])}, info=`, info);
      else this.log(`channel message, event=${_optionalChain([info, 'optionalAccess', _2 => _2.event])}`);
      if (info) {
        const { event, args } = info;
        await this.emitSuper(event, ...args);
      }
    });
  }
  get shortId() {
    return this.name.substr(0, 6);
  }
  async emitSuper(event, ...args) {
    return await super.emit(event, ...args);
  }
  async emit(event, ...args) {
    try {
      if (this.debug)
        this.log(`emit(${String(event)})`, event);
      else this.log(`emit(${String(event)})`, args.length);
      if (!this.channel.isConnected) {
        this.log.warn("channel not connected");
        return false;
      }
      const data = await this.encoder.encode({ event, args });
      this.channel.postMessage(data);
      return true;
    } catch (err) {
      this.log.warn(`emit(${String(event)})`, err);
    }
    return false;
  }
};
function usePubSub(opt) {
  return new PubSub(opt);
}




exports.PubSub = PubSub; exports.usePubSub = usePubSub;
//# sourceMappingURL=chunk-AQHSLGFK.cjs.map