"use strict";Object.defineProperty(exports, "__esModule", {value: true}); function _nullishCoalesce(lhs, rhsFn) { if (lhs != null) { return lhs; } else { return rhsFn(); } } function _optionalChain(ops) { let lastAccessLHS = undefined; let value = ops[0]; let i = 1; while (i < ops.length) { const op = ops[i]; const fn = ops[i + 1]; i += 2; if ((op === 'optionalAccess' || op === 'optionalCall') && value == null) { return undefined; } if (op === 'access' || op === 'optionalAccess') { lastAccessLHS = value; value = fn(value); } else if (op === 'call' || op === 'optionalCall') { value = fn((...args) => value.call(lastAccessLHS, ...args)); lastAccessLHS = undefined; } } return value; }





var _chunkVAG3XY63cjs = require('./chunk-VAG3XY63.cjs');


var _chunkW3WUDQICcjs = require('./chunk-W3WUDQIC.cjs');

// src/common/schema/schema.ts
function preParse(obj, info) {
  if (obj == null) {
    if (info._default != null) {
      if (_chunkVAG3XY63cjs.isFunction.call(void 0, info._default))
        obj = info._default();
      else
        obj = info._default;
    }
  }
  if (obj == null && info._optional === true)
    return void 0;
  if (obj == null)
    throw new Error("cannot be undefined");
  if (!info._check || info._check(obj))
    return obj;
  throw new Error("wrong value");
}
function generic(type, opt) {
  const info = {
    parse(obj) {
      return preParse(obj, this);
    },
    _check() {
      return true;
    },
    ...opt,
    type,
    optional() {
      this._optional = true;
      return this;
    },
    default(value) {
      this._default = value;
      return this;
    },
    props(props) {
      this._props = props;
      return this;
    }
  };
  return info;
}
function string() {
  return generic("string", {
    _check: _chunkVAG3XY63cjs.isString
  });
}
function number() {
  return generic("number", {
    _check: _chunkVAG3XY63cjs.isNumber
  });
}
function boolean() {
  return generic("boolean", {
    _check: _chunkVAG3XY63cjs.isBoolean
  });
}
function object(tobj) {
  const info = generic("object", {
    _object: tobj,
    parse(obj) {
      if (obj == null && this._optional === true)
        return void 0;
      const newObj = {};
      if (!_chunkVAG3XY63cjs.isObject.call(void 0, obj))
        return new Error("expected object input");
      if (!_chunkVAG3XY63cjs.isObject.call(void 0, this._object))
        return new Error("expected object definition");
      for (const [key, info2] of Object.entries(this._object)) {
        const value = info2.parse(obj[key]);
        if (value !== void 0)
          newObj[key] = value;
      }
      return newObj;
    }
  });
  return info;
}
function union(options) {
  return generic(_nullishCoalesce(_optionalChain([_chunkW3WUDQICcjs.first.call(void 0, options), 'optionalAccess', _ => _.type]), () => ( "any")), {
    _union: options,
    _check(obj) {
      return _nullishCoalesce(_optionalChain([this, 'access', _2 => _2._union, 'optionalAccess', _3 => _3.some, 'call', _4 => _4((t) => t._check(obj))]), () => ( true));
    }
  });
}
function literal(value) {
  return generic("string", {
    _check: (v) => v === value
  });
}








exports.string = string; exports.number = number; exports.boolean = boolean; exports.object = object; exports.union = union; exports.literal = literal;
//# sourceMappingURL=chunk-GOM6TL27.cjs.map