"use strict";Object.defineProperty(exports, "__esModule", {value: true});

var _chunkLXSY24WIcjs = require('./chunk-LXSY24WI.cjs');


var _chunkSLEHBFHVcjs = require('./chunk-SLEHBFHV.cjs');


var _chunk7BEQHGH5cjs = require('./chunk-7BEQHGH5.cjs');


var _chunkVAG3XY63cjs = require('./chunk-VAG3XY63.cjs');


var _chunkLHP7OTMVcjs = require('./chunk-LHP7OTMV.cjs');


var _chunkHHZVPIBDcjs = require('./chunk-HHZVPIBD.cjs');


var _chunkYY4AHBBLcjs = require('./chunk-YY4AHBBL.cjs');

// src/common/network.ts
var defaultOptions = {
  cache: "no-cache",
  redirect: "follow",
  headers: {}
};
function parseBasicAuth(url) {
  const m = /:\/\/([^@]*)@/.exec(url);
  if (m && m[1]) {
    const [username, password] = m[1].split(":", 2);
    return {
      url: url.replace(`${m[1]}@`, ""),
      username,
      password
    };
  }
}
async function fetchBasic(url, fetchOptions = {}, fetchFn = fetch) {
  try {
    if (_chunkVAG3XY63cjs.isArray.call(void 0, fetchOptions))
      fetchOptions = _chunk7BEQHGH5cjs.deepMerge.call(void 0, {}, ..._chunkLHP7OTMVcjs.arrayFlatten.call(void 0, fetchOptions));
    const auth = parseBasicAuth(String(url));
    if (auth) {
      url = auth.url;
      fetchOptions = _chunk7BEQHGH5cjs.deepMerge.call(void 0, 
        {},
        fetchOptions,
        fetchOptionsBasicAuth(auth.username, auth.password)
      );
    }
    if (
      // @ts-expect-error headers
      fetchOptions.headers != null && !(fetchOptions.headers instanceof Headers)
    ) {
      fetchOptions.headers = new Headers(fetchOptions.headers);
    }
    const response = await fetchFn(String(url), fetchOptions);
    if (response.status < 400)
      return response;
    const log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "zeed:network");
    try {
      log.warn(`Fetch of ${String(url)} returned status=${response.status}. Options:`, fetchOptions);
      log.warn(`Response: ${await response.text()}`);
    } catch (err) {
      log.error("Exception:", err);
    }
  } catch (err) {
    const log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "zeed:network");
    log.error("fetchBasic", err);
  }
}
async function fetchJson(url, fetchOptions = {}, fetchFn = fetch) {
  try {
    const res = await fetchBasic(
      url,
      [
        {
          method: "GET",
          headers: {
            Accept: "application/json"
          }
        },
        fetchOptions
      ],
      fetchFn
    );
    if (res)
      return await res.json();
  } catch (err) {
    const log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "zeed:network");
    log.error("fetchJSON error:", err);
  }
}
async function fetchText(url, fetchOptions = {}, fetchFn = fetch) {
  try {
    const res = await fetchBasic(
      url,
      [defaultOptions, { method: "GET" }, fetchOptions],
      fetchFn
    );
    if (res)
      return await res.text();
  } catch (err) {
    const log = _chunkLXSY24WIcjs.DefaultLogger.call(void 0, "zeed:network");
    log.error("fetchHTML error:", err);
  }
}
function fetchOptionsFormURLEncoded(data, method = "POST") {
  return {
    method,
    ...defaultOptions,
    headers: {
      "Content-Type": "application/x-www-form-urlencoded; charset=utf-8"
    },
    body: _chunkSLEHBFHVcjs.encodeQuery.call(void 0, data)
  };
}
function fetchOptionsJson(data, method = "POST") {
  return {
    method,
    ...defaultOptions,
    headers: {
      "Content-Type": "application/json; charset=utf-8"
      // Accept: "application/json",
    },
    body: _chunkYY4AHBBLcjs.jsonStringifySafe.call(void 0, data)
  };
}
function fetchOptionsBasicAuth(username, password) {
  return {
    headers: {
      Authorization: `Basic ${_chunkHHZVPIBDcjs.toBase64.call(void 0, `${username}:${password}`)}`
    }
  };
}









exports.parseBasicAuth = parseBasicAuth; exports.fetchBasic = fetchBasic; exports.fetchJson = fetchJson; exports.fetchText = fetchText; exports.fetchOptionsFormURLEncoded = fetchOptionsFormURLEncoded; exports.fetchOptionsJson = fetchOptionsJson; exports.fetchOptionsBasicAuth = fetchOptionsBasicAuth;
//# sourceMappingURL=chunk-UB27HMP4.cjs.map