type RoundingMode = (value: number) => number;
declare function isHalf(value: number): boolean;
declare function isEven(value: number): boolean;
declare const roundUp: RoundingMode;
declare const roundDown: RoundingMode;
declare const roundHalfUp: RoundingMode;
/**
 * Round a number with half values to nearest odd integer.
 */
declare const roundHalfOdd: RoundingMode;
/**
 * Round a number with half values to nearest integer farthest from zero.
 */
declare const roundHalfAwayFromZero: RoundingMode;
/**
 * Round a number with half values down.
 */
declare const roundHalfDown: RoundingMode;
/**
 * Round a number with half values to nearest even integer.
 * https://wiki.c2.com/?BankersRounding
 */
declare const roundHalfEven: RoundingMode;
/**
 * Round a number with half values to nearest integer closest to zero.
 */
declare const roundHalfTowardsZero: RoundingMode;
/**
 * This is useful for percentages that should sum up to 100.
 * But can also be fine tuned.
 *
 * Original from https://github.com/super-ienien/percent-round
 */
declare function roundArrayOfNumbersToMatchSum(ipt: number[], max?: number, decimalPlaces?: number): number[];
declare function roundArrayOfObjectsToMatchSum<T extends Record<string, any>>(arr: T[], name: string, max?: number, decimalPlaces?: number): T[];

export { type RoundingMode, isEven, isHalf, roundArrayOfNumbersToMatchSum, roundArrayOfObjectsToMatchSum, roundDown, roundHalfAwayFromZero, roundHalfDown, roundHalfEven, roundHalfOdd, roundHalfTowardsZero, roundHalfUp, roundUp };
