"use strict";



var _chunkSLEHBFHVcjs = require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/data/url.spec.ts
describe("url", () => {
  it("split string to URLs", () => {
    const sample = "https://example.com has <strange & fancy> some example.com at end http://example.com some";
    expect(_chunkSLEHBFHVcjs.linkifyPlainText.call(void 0, sample)).toBe(
      '<a target="_blank" href="https://example.com">example.com</a> has &lt;strange &amp; fancy&gt; some example.com at end <a target="_blank" href="http://example.com">example.com</a> some'
    );
  });
  it("should make human readable url", () => {
    expect(_chunkSLEHBFHVcjs.toHumanReadableUrl.call(void 0, "example.com")).toEqual("example.com");
    expect(_chunkSLEHBFHVcjs.toHumanReadableUrl.call(void 0, "https://www.receipts-app.com/")).toEqual("receipts-app.com");
    expect(_chunkSLEHBFHVcjs.toHumanReadableUrl.call(void 0, "https://pdfify.app/")).toEqual("pdfify.app");
    expect(_chunkSLEHBFHVcjs.toHumanReadableUrl.call(void 0, "https://pdfify.app/more/subpage.html?query=123")).toEqual("pdfify.app/more/subpage.html?query=123");
  });
  it("should build query", () => {
    const data = {
      a: 1,
      b: "2",
      c: null,
      d: void 0,
      e: 0
    };
    expect(_chunkSLEHBFHVcjs.encodeQuery.call(void 0, data)).toMatchInlineSnapshot('"a=1&b=2&e=0"');
    expect(_chunkSLEHBFHVcjs.encodeQuery.call(void 0, data, (v) => !!v)).toMatchInlineSnapshot('"a=1&b=2"');
  });
});
//# sourceMappingURL=url.spec.cjs.map