import { Type, ObjectInput, ObjectOutput } from './types.js';

declare function string(): Type<string>;
declare function number(): Type<number>;
declare function boolean(): Type<boolean>;
declare function object<T extends ObjectInput>(tobj: T): ObjectOutput<T>;
type ExtractLiteral<T> = T extends Type<infer U> ? U : never;
type TransformToUnion<T extends (Type<any>)[]> = T extends Array<infer U> ? ExtractLiteral<U> : never;
declare function union<T extends (Type<any>)[]>(options: T): Type<TransformToUnion<T>>;
type Literal = string | number | bigint | boolean;
declare function literal<T extends Literal>(value: T): Type<T>;

export { boolean, literal, number, object, string, union };
