"use strict";





var _chunkGOM6TL27cjs = require('../../chunk-GOM6TL27.cjs');
require('../../chunk-VFIICDKU.cjs');
require('../../chunk-PDXKNB3S.cjs');
require('../../chunk-XR7AMYN7.cjs');
require('../../chunk-SLEHBFHV.cjs');
require('../../chunk-KMMN6P2X.cjs');
require('../../chunk-AGQV4BOO.cjs');
require('../../chunk-LURLRIHI.cjs');
require('../../chunk-67Q7IWIS.cjs');
require('../../chunk-B4JXPT6I.cjs');
require('../../chunk-KCBJGJ24.cjs');
require('../../chunk-RPAQV2V5.cjs');
require('../../chunk-SVJWXMAG.cjs');
require('../../chunk-TFJRKEPC.cjs');
require('../../chunk-MPD2DJAD.cjs');
require('../../chunk-ZGKV237Z.cjs');
require('../../chunk-7BEQHGH5.cjs');
require('../../chunk-VAG3XY63.cjs');
require('../../chunk-FEYF6QXS.cjs');
require('../../chunk-SFVQNT7T.cjs');
require('../../chunk-N7OUNPMM.cjs');
require('../../chunk-Z4FNOCPD.cjs');
require('../../chunk-GWXPD6I7.cjs');
require('../../chunk-N5KTMDVO.cjs');
require('../../chunk-B3U4FDQH.cjs');
require('../../chunk-YELWQAMG.cjs');
require('../../chunk-RHWKNEUH.cjs');
require('../../chunk-DRU33ZUG.cjs');
require('../../chunk-LHP7OTMV.cjs');
require('../../chunk-5BF2LEAU.cjs');
require('../../chunk-6T6PI6XG.cjs');
require('../../chunk-TUWUD5A6.cjs');
require('../../chunk-CUGOCLWN.cjs');


var _chunkW3WUDQICcjs = require('../../chunk-W3WUDQIC.cjs');
require('../../chunk-BXM45HLQ.cjs');
require('../../chunk-HHZVPIBD.cjs');
require('../../chunk-YY4AHBBL.cjs');
require('../../chunk-IMCDDJAJ.cjs');

// src/common/schema/schema.spec.ts
describe("schema", () => {
  it("create schema", async () => {
    const schema = _chunkGOM6TL27cjs.object.call(void 0, {
      id: _chunkGOM6TL27cjs.string.call(void 0, ).default(() => "123"),
      name: _chunkGOM6TL27cjs.string.call(void 0, ),
      age: _chunkGOM6TL27cjs.number.call(void 0, ).optional(),
      obj: _chunkGOM6TL27cjs.object.call(void 0, {
        test: _chunkGOM6TL27cjs.number.call(void 0, )
      }).optional()
    });
    const sample = {
      name: "Hello",
      age: 42
    };
    expect(_chunkW3WUDQICcjs.cloneJsonObject.call(void 0, schema)).toMatchInlineSnapshot(`
      Object {
        "_object": Object {
          "age": Object {
            "_optional": true,
            "type": "number",
          },
          "id": Object {
            "type": "string",
          },
          "name": Object {
            "type": "string",
          },
          "obj": Object {
            "_object": Object {
              "test": Object {
                "type": "number",
              },
            },
            "_optional": true,
            "type": "object",
          },
        },
        "type": "object",
      }
    `);
    expect(schema.parse(sample)).toMatchInlineSnapshot(`
      Object {
        "age": 42,
        "id": "123",
        "name": "Hello",
      }
    `);
  });
  it("union", async () => {
    const literals = [
      _chunkGOM6TL27cjs.literal.call(void 0, "one"),
      _chunkGOM6TL27cjs.literal.call(void 0, "two"),
      _chunkGOM6TL27cjs.literal.call(void 0, "three")
    ];
    const schema = _chunkGOM6TL27cjs.object.call(void 0, {
      id: _chunkGOM6TL27cjs.string.call(void 0, ).default(() => "123").props({
        someProp: "someValue"
      }),
      literal: _chunkGOM6TL27cjs.literal.call(void 0, "demo"),
      name: _chunkGOM6TL27cjs.union.call(void 0, literals)
    });
    const sample = {
      literal: "demo",
      name: "two"
    };
    expect(_chunkW3WUDQICcjs.cloneJsonObject.call(void 0, schema)).toMatchInlineSnapshot(`
      Object {
        "_object": Object {
          "id": Object {
            "_props": Object {
              "someProp": "someValue",
            },
            "type": "string",
          },
          "literal": Object {
            "type": "string",
          },
          "name": Object {
            "_union": Array [
              Object {
                "type": "string",
              },
              Object {
                "type": "string",
              },
              Object {
                "type": "string",
              },
            ],
            "type": "string",
          },
        },
        "type": "object",
      }
    `);
    expect(schema.parse(sample)).toMatchInlineSnapshot(`
      Object {
        "id": "123",
        "literal": "demo",
        "name": "two",
      }
    `);
  });
});
//# sourceMappingURL=schema.spec.cjs.map