/**
 * Represents the configuration options for parsing command line arguments.
 */
interface ParseConfig {
    args?: string[];
    alias?: Record<string, string[]>;
    normalize?: (value: string) => string;
    booleanArgs?: string | string[];
    listArgs?: string | string[];
    numberArgs?: string | string[];
}
/**
 * Parses command line arguments and returns an object containing the parsed options.
 *
 * @param config - Configuration options for parsing the arguments.
 * @returns An object containing the parsed options.
 */
declare function parseArgs(config?: ParseConfig): Record<string, any>;

export { parseArgs };
