/** Try to use `~` for HOME folder if possible */
declare function toHumanReadableFilePath(path: string): string;
declare function exists(path: string): Promise<boolean>;
declare function isHiddenPath(path: string): boolean;
/** Create missing folders e.g. `/a/b/c` will create folders `/a/b/c` */
declare function ensureFolder(...parts: string[]): Promise<string>;
/** Create missing folder to file location e.g. `/a/b/c/s.txt` will create folders `/a/b/c` */
declare function ensureFolderForFile(...parts: string[]): Promise<string>;
declare function removeFolder(...parts: string[]): Promise<string>;
declare function readText(...parts: string[]): Promise<string | undefined>;
declare function readJson<T = object>(...parts: string[]): Promise<T | undefined>;
declare function readBin(...parts: string[]): Promise<Uint8Array | undefined>;
/** @deprecated use readJson or readBin */
declare function readData(...parts: string[]): Promise<Uint8Array | undefined>;
declare function writeText(path: string, content: string, createFolders?: boolean): Promise<void>;
/** @deprecated use writeBin or writeJson */
declare function writeData(path: string, content: object | Uint8Array, createFolders?: boolean): Promise<void>;
declare function writeBin(path: string, content: Uint8Array, info?: {
    createFolders?: boolean;
}): Promise<void>;
declare function writeJson<T = object>(path: string, content: T, info?: {
    createFolders?: boolean;
    pretty?: boolean;
}): Promise<void>;

export { ensureFolder, ensureFolderForFile, exists, isHiddenPath, readBin, readData, readJson, readText, removeFolder, toHumanReadableFilePath, writeBin, writeData, writeJson, writeText };
